#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "timing.h"


int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;

double *a,*b,*c;
a = (double *) malloc(2*N * sizeof(double) );
b = (double *) malloc(2*N * sizeof(double) );
c = (double *) malloc(2*N * sizeof(double) );


for(int i=0; i<2*N; i++) {
	a[i] = (double) rand() / RAND_MAX;
	b[i] = (double) rand() / RAND_MAX;
	c[i] = 0.;
}

get_ticks(ticksB4);

for(int i=0; i<10000000; i++)
{
	for(int j=0;j<N;j++)
	{
		c[j] = a[j] * b[j];
	}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("runtime without vectorization: %g\n\n", ticks/freq);



get_ticks(ticksB4);

for(int i=0; i<10000000; i++)
{
#pragma omp simd
	for(int j=0;j<N;j++)
	{
		c[j] = a[j] * b[j];
	}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("runtime with vectorization: %g\n\n", ticks/freq);


return 0;
}
